--- main/features.c-orig        2009-11-17 14:58:45.000000000 +0900
+++ main/features.c     2009-11-19 15:05:22.000000000 +0900
@@ -551,6 +551,7 @@ static struct parkeduser *park_space_res
        } else {
                int start;
                struct parkeduser *cur = NULL;
+               int j;

                /* Select parking space within range */
                parking_range = parkinglot->parking_stop - parkinglot->parking_start + 1;
@@ -561,7 +562,7 @@ static struct parkeduser *park_space_res
                        start = parkinglot->parking_start;
                }

-               for (i = start; 1; i++) {
+               for (i = start, j = 0; j < parking_range; i++, j++) {
                        if (i == parkinglot->parking_stop + 1) {
                                i = parkinglot->parking_start - 1;
                                continue;
@@ -579,7 +580,7 @@ static struct parkeduser *park_space_res
                        }
                }

-               if (i == start - 1 && cur) {
+               if (j == parking_range || (i == start - 1 && cur)) {
                        ast_log(LOG_WARNING, "No more parking spaces\n");
                        ast_free(pu);
                        AST_LIST_UNLOCK(&parkinglot->parkings);
